{Originally from Frederic Gaonac'h }
{slightly corrected by Valery Votintsev [vv]}
program tetrisa2;
uses crt, graph;
type tableau=Array[1..10,1..29]of integer;
switch= array[1..4,1..6] of integer;

const
  d500=5;  {vv delay constant. Increase this if very fast}
  d6000=600; {vv delay constant. Increase this if very fast}

function max(a,b,c: integer):integer;
begin
    if (a>=b)and(a>=c) then max:=a;
    if (b>=a)and(b>=c) then max:=b;
    if (c>=a)and(c>=b) then max:=c;
end;

function min(a,b,c: integer):integer;
begin
   if (a<=b)and(a<=c) then min:=a;
   if (b<=a)and(b<=c) then min:=b;
   if (c<=a)and(c<=b) then min:=c;
end;

function descent(t:tableau;grille:switch; b,c,i: integer):integer;

begin
    while
    (t[grille[b,1]+c,i+1+grille[b,2]]=0)and(t[grille[b,3]+c,i+1+grille[b,4]]=0)and(t[grille[b,5]+c,i+1+grille[b,6]]=0)and
    (t[c,i+1]=0)and(i+grille[b,2]<29)and(i+grille[b,4]<29)and(i+grille[b,6]<29)and(i<29)
    do i:=i+1;
descent:=i;
end;

procedure pause(var son: boolean);
var  i,j,k: integer;
begin
    for i:=1 to 2 do begin
        if i=1 then
        setcolor(3)
        else setcolor(0);
    outtextxy(30,20,'Adaptation of the game:');
    outtextxy(260,140,'Faster!:       8');
    outtextxy(260,160,'Pause:         P');
    outtextxy(260,180,'First Handicap:H');
    outtextxy(260,270,'Sound/Sil.:    S');
    outtextxy(260,290,'Iwannaquit:  Esc');
{vv    outtextxy(260,290,'Iwannaquit:    Q');}
        if i=1 then begin
            repeat
                for j:=1 to 20  do begin
                    for k:=1 to 2 do begin
                        if k=1 then setcolor(4) else setcolor(0);
                    outtextxy(230+1*j,20,'F');
                    outtextxy(240+2*j,20,'r');
                    outtextxy(250+3*j,20,'e');
                    outtextxy(260+4*j,20,'d');
                        if k=1 then delay(d500);
                    end;
                end;
                for j:=20 downto 1  do begin
                    for k:=1 to 2 do begin
                        if k=1 then setcolor(4) else setcolor(0);
                    outtextxy(230+1*j,20,'F');
                    outtextxy(240+2*j,20,'r');
                    outtextxy(250+3*j,20,'e');
                    outtextxy(260+4*j,20,'d');
                        if k=1 then delay(d500);
                    end;
                end;
            until keypressed;

        k:=ord(readkey);
            if k=ord('s') then
                if son=true then son:=false else son:=true;
{vv            if k=ord('q') then halt;}
{vv}        if (k=27) or (k=ord('q')) then begin
               closegraph;
               halt;
            end;
        end;
    end;
end;

var a, b1, b2, c1, c2, i1, i2, j, k, l, m1, m2, n, r, r2, x1, x2, v1, v2, w1, w2,
z, nbre, lignes1, lignes2, fin1, fin2, pilote, mode, ncp1, ecp1, ncp2, ecp2: integer;
t, tbis: tableau;
t1, t2, t3, t4, t5, t10, t14, grille1, grille2: switch;
absents, presents, test, test2, son: boolean;
p1, p2: longint;
s: string;

begin
t1[1,1]:=0; t1[1,2]:=1; t1[1,3]:=0; t1[1,4]:=-1; t1[1,5]:=1; t1[1,6]:=-1;
t1[2,1]:=1; t1[2,2]:=0; t1[2,3]:=-1; t1[2,4]:=0; t1[2,5]:=-1; t1[2,6]:=-1;
t1[3,1]:=0; t1[3,2]:=1; t1[3,3]:=0; t1[3,4]:=-1; t1[3,5]:=-1; t1[3,6]:=1;
t1[4,1]:=1; t1[4,2]:=0; t1[4,3]:=-1; t1[4,4]:=0; t1[4,5]:=1; t1[4,6]:=1;
t2[1,1]:=1; t2[1,2]:=0; t2[1,3]:=0; t2[1,4]:=-1; t2[1,5]:=-1; t2[1,6]:=-1;
t2[2,1]:=0; t2[2,2]:=-1; t2[2,3]:=-1; t2[2,4]:=0; t2[2,5]:=-1; t2[2,6]:=1;
t3[1,1]:=1; t3[1,2]:=0; t3[1,3]:=-1; t3[1,4]:=0; t3[1,5]:=0; t3[1,6]:=1;
t3[2,1]:=1; t3[2,2]:=0; t3[2,3]:=0; t3[2,4]:=-1; t3[2,5]:=0; t3[2,6]:=1;
t3[3,1]:=0; t3[3,2]:=-1; t3[3,3]:=-1; t3[3,4]:=0; t3[3,5]:=1; t3[3,6]:=0;
t3[4,1]:=0; t3[4,2]:=-1; t3[4,3]:=0; t3[4,4]:=1; t3[4,5]:=-1; t3[4,6]:=0;
t4[1,1]:=0; t4[1,2]:=-1; t4[1,3]:=0; t4[1,4]:=1; t4[1,5]:=0; t4[1,6]:=2;
t4[2,1]:=1; t4[2,2]:=0; t4[2,3]:=2; t4[2,4]:=0; t4[2,5]:=-1; t4[2,6]:=0;
t5[1,1]:=1; t5[1,2]:=0; t5[1,3]:=1; t5[1,4]:=-1; t5[1,5]:=0; t5[1,6]:=-1;
t10[1,1]:=0; t10[1,2]:=-1; t10[1,3]:=0; t10[1,4]:=1; t10[1,5]:=-1; t10[1,6]:=-1;
t10[2,1]:=1; t10[2,2]:=0; t10[2,3]:=-1; t10[2,4]:=0; t10[2,5]:=-1; t10[2,6]:=1;
t10[3,1]:=0; t10[3,2]:=1; t10[3,3]:=0; t10[3,4]:=-1; t10[3,5]:=1; t10[3,6]:=1;
t10[4,1]:=1; t10[4,2]:=0; t10[4,3]:=-1; t10[4,4]:=0; t10[4,5]:=1; t10[4,6]:=-1;
t14[1,1]:=0; t14[1,2]:=-1; t14[1,3]:=1; t14[1,4]:=-1; t14[1,5]:=-1; t14[1,6]:=0;
t14[2,1]:=0; t14[2,2]:=1; t14[2,3]:=-1; t14[2,4]:=0; t14[2,5]:=-1; t14[2,6]:=-1;

    for j:=1 to 10 do begin
        for k:=1 to 29 do begin
        t[j,k]:=0;
        tbis[j,k]:=0;
        end;
    end;
    
ncp1:=0;
ecp1:=0;
ncp2:=0;
ecp2:=0;

pilote:=detect;
initGraph(pilote,mode,'c:\tp\bgi');
clearviewport;
setcolor(8);
setbkcolor(black);
    for j:=1 to 30 do
    line(20,j*15+20,220,j*15+20);
    for j:=1 to 11 do
    line(j*20,35,j*20,470);

    for j:=1 to 30 do
    line(420,j*15+20,620,j*15+20);
    for j:=1 to 11 do
    line(j*20+400,35,j*20+400,470);


setcolor(3);
outtextxy(270,70,'Player  1');
outtextxy(270,90,'Points: 0');
outtextxy(270,110,'Lines:  0');

outtextxy(270,350,'Player  2');
outtextxy(270,370,'Points: 0');
outtextxy(270,390,'Lines:  0');

outtextxy(270,220,'Level:  01');

p1:=0;
p2:=0;
lignes1:=0;
lignes2:=0;
n:=1;
son:=true;
randomize;

m1:=0;
i1:=1;
x1:=110;
c1:=5;
b1:=1;

m2:=0;
i2:=1;
x2:=510;
c2:=5;
b2:=1;

r:=random(7)+1;
r2:=random(7)+1;

test:=false;
test2:=false;

   repeat
        if r=7 then r:=14;
        if r=6 then r:=10;
        if r=1 then grille1:=t1;
        if r=2 then grille1:=t2;
        if r=3 then grille1:=t3;
        if r=4 then grille1:=t4;
        if r=5 then grille1:=t5;
        if r=10 then grille1:=t10;
        if r=14 then grille1:=t14;

        if r2=7 then r2:=14;
        if r2=6 then r2:=10;
        if r2=1 then grille2:=t1;
        if r2=2 then grille2:=t2;
        if r2=3 then grille2:=t3;
        if r2=4 then grille2:=t4;
        if r2=5 then grille2:=t5;
        if r2=10 then grille2:=t10;
        if r2=14 then grille2:=t14;

        repeat
        z:=0;
            if i1<>1 then begin
            setfillstyle(1,0);
            floodfill(x1,i1*15+25,8);
            floodfill(grille1[b1,1]*20+x1,(i1+grille1[b1,2])*15+25,8);
            floodfill(grille1[b1,3]*20+x1,(i1+grille1[b1,4])*15+25,8);
            floodfill(grille1[b1,5]*20+x1,(i1+grille1[b1,6])*15+25,8);
            end;

            if i2<>1 then begin
            setfillstyle(1,0);
            floodfill(x2,i2*15+25,8);
            floodfill(grille2[b2,1]*20+x2,(i2+grille2[b2,2])*15+25,8);
            floodfill(grille2[b2,3]*20+x2,(i2+grille2[b2,4])*15+25,8);
            floodfill(grille2[b2,5]*20+x2,(i2+grille2[b2,6])*15+25,8);
            end;

        i1:=i1+1;
        i2:=i2+1;

            while keypressed do begin
            z:=ord(readkey);
{vv}        if (z=27) then begin
{vv}               closegraph;
{vv}               halt;
{vv}            end;

            v1:=min(grille1[b1,1],grille1[b1,3],grille1[b1,5]);
            w1:=max(grille1[b1,1],grille1[b1,3],grille1[b1,5]);
            v2:=min(grille2[b2,1],grille2[b2,3],grille2[b2,5]);
            w2:=max(grille2[b2,1],grille2[b2,3],grille2[b2,5]);

                if (z=ord('q'))and(c1+v1>1)and(t[c1+grille1[b1,1]-1,i1+grille1[b1,2]]=0)
                and(t[c1+grille1[b1,3]-1,i1+grille1[b1,4]]=0)and(t[c1+grille1[b1,5]-1,i1+grille1[b1,6]]=0) then begin
                x1:=x1-20; c1:=c1-1; end;

                if (z=ord('d'))and(c1+w1<10)and(t[c1+grille1[b1,1]+1,i1+grille1[b1,2]]=0)
                and(t[c1+grille1[b1,3]+1,i1+grille1[b1,4]]=0)and(t[c1+grille1[b1,5]+1,i1+grille1[b1,6]]=0) then begin
                x1:=x1+20; c1:=c1+1; end;

                if z=ord('a') then begin
                    while (c1+v1>1)and(t[c1+grille1[b1,1]-1,i1+grille1[b1,2]]=0)
                    and(t[c1+grille1[b1,3]-1,i1+grille1[b1,4]]=0)and(t[c1+grille1[b1,5]-1,i1+grille1[b1,6]]=0) do begin
                    x1:=x1-20;c1:=c1-1;end;
                end;

                if z=ord('e') then begin
                    while (c1+w1<10)and(t[c1+grille1[b1,1]+1,i1+grille1[b1,2]]=0)
                    and(t[c1+grille1[b1,3]+1,i1+grille1[b1,4]]=0)and(t[c1+grille1[b1,5]+1,i1+grille1[b1,6]]=0) do begin
                    x1:=x1+20; c1:=c1+1; end;
                end;

                if z=ord('x') then begin
                setcolor(0);
                str(p1, s);
                outtextxy(334,90,s);
                p1:=p1+(30-i1)*SQR(n) div 4;
                setcolor(3);
                str(p1, s);
                outtextxy(334,90,s);
                i1:=descent(t,grille1,b1,c1,i1);
                end;

                if z=ord('s') then begin
                a:=1;
                    if (r=2)or(r=14)or(r=4) then a:=2;
                    if (r=1)or(r=10)or(r=3) then a:=4;
                v1:=min(grille1[(b1 mod a)+1,1],grille1[(b1 mod a)+1,3],grille1[(b1 mod a)+1,5]);
                w1:=max(grille1[(b1 mod a)+1,1],grille1[(b1 mod a)+1,3],grille1[(b1 mod a)+1,5]);

                    if (c1+v1>0)and(c1+w1<11)and(t[c1+grille1[(b1 mod a)+1,1],i1+grille1[(b1 mod a)+1,2]]=0)
                    and(t[c1+grille1[(b1 mod a)+1,3],i1+grille1[(b1 mod a)+1,4]]=0)
                    and(t[c1+grille1[(b1 mod a)+1,5],i1+grille1[(b1 mod a)+1,6]]=0)
                    then begin
                    m1:=m1+1;
                    b1:=(m1 mod a)+1;
                    end;
                end;

                if (z=ord('4'))and(c2+v2>1)and(tbis[c2+grille2[b2,1]-1,i2+grille2[b2,2]]=0)
                and(tbis[c2+grille2[b2,3]-1,i2+grille2[b2,4]]=0)and(tbis[c2+grille2[b2,5]-1,i2+grille2[b2,6]]=0) then begin
                x2:=x2-20; c2:=c2-1; end;

                if (z=ord('6'))and(c2+w2<10)and(tbis[c2+grille2[b2,1]+1,i2+grille2[b2,2]]=0)
                and(tbis[c2+grille2[b2,3]+1,i2+grille2[b2,4]]=0)and(tbis[c2+grille2[b2,5]+1,i2+grille2[b2,6]]=0) then begin
                x2:=x2+20; c2:=c2+1; end;

                if z=ord('7') then begin
                    while (c2+v2>1)and(tbis[c2+grille2[b2,1]-1,i2+grille2[b2,2]]=0)
                    and(tbis[c2+grille2[b2,3]-1,i2+grille2[b2,4]]=0)and(tbis[c2+grille2[b2,5]-1,i2+grille2[b2,6]]=0) do begin
                    x2:=x2-20; c2:=c2-1; end;
                end;

                if z=ord('9') then begin
                    while (c2+w2<10)and(tbis[c2+grille2[b2,1]+1,i2+grille2[b2,2]]=0)
                    and(tbis[c2+grille2[b2,3]+1,i2+grille2[b2,4]]=0)and(tbis[c2+grille2[b2,5]+1,i2+grille2[b2,6]]=0) do begin
                    x2:=x2+20; c2:=c2+1; end;
                end;

                if z=ord('2') then begin
                setcolor(0);
                str(p2, s);
                outtextxy(334,370,s);
                p2:=p2+(30-i2)*SQR(n) div 4;
                setcolor(3);
                str(p2, s);
                outtextxy(334,370,s);
                i2:=descent(tbis,grille2,b2,c2,i2);
                end;

                if z=ord('5') then begin
                a:=1;
                    if (r2=2)or(r2=14)or(r2=4) then a:=2;
                    if (r2=1)or(r2=10)or(r2=3) then a:=4;
                v2:=min(grille2[(b2 mod a)+1,1],grille2[(b2 mod a)+1,3],grille2[(b2 mod a)+1,5]);
                w2:=max(grille2[(b2 mod a)+1,1],grille2[(b2 mod a)+1,3],grille2[(b2 mod a)+1,5]);

                    if (c2+v2>0)and(c2+w2<11)and(t[c2+grille2[(b2 mod a)+1,1],i2+grille2[(b2 mod a)+1,2]]=0)
                    and(tbis[c2+grille2[(b2 mod a)+1,3],i2+grille2[(b2 mod a)+1,4]]=0)
                    and(tbis[c2+grille2[(b2 mod a)+1,5],i2+grille2[(b2 mod a)+1,6]]=0)
                    then begin
                    m2:=m2+1;
                    b2:=(m2 mod a)+1;
                    end;
                end;

                if z=ord('8') then begin
                setcolor(0);
                str(n, s);
                outtextxy(334,220,s);
                n:=n+1;
                setcolor(3);
                str(n, s);
                outtextxy(334,220,s);
                end;

                if z=ord('p') then begin
                    repeat
                        for j:=1 to 25  do begin
                            for k:=1 to 2 do begin
                                if k=1 then setcolor(4) else setcolor(0);
                            outtextxy(290-3*j,20,'P');
                            outtextxy(300-j,20,'a');
                            outtextxy(310,20,'u');
                            outtextxy(320+j,20,'s');
                            outtextxy(330+3*j,20,'e');
                                if k=1 then delay(d500);
                            end;
                        end;
                        for j:=25 downto 1  do begin
                            for k:=1 to 2 do begin
                                if (k=1) then setcolor(4) else setcolor(0);
                            outtextxy(290-3*j,20,'P');
                            outtextxy(300-j,20,'a');
                            outtextxy(310,20,'u');
                            outtextxy(320+j,20,'s');
                            outtextxy(330+3*j,20,'e');
                                if k=1 then delay(d500);
                            end;
                        end;
                    until keypressed;
                end;

                if (z=ord('h'))and(p1=0)and(p2=0) then begin
                    setcolor(3);
                    outtextxy(270,160,'Height ?');
                    repeat
                        repeat until keypressed;
                    z:=ord(readkey)-ord('0');
                    until (z>=0)and(z<10);
                setcolor(0);
                outtextxy(270,160,'Height ?');
                setfillstyle(1,9);
                     for j:=29 downto 30-z do begin
                         for k:=1 to 10 do begin
                             if (random(2)=1)or(k=30-j) then begin
                             t[k,j]:=9;
                             floodfill(k*20+10,j*15+25,8);
                             end;
                         end;
                     end;
                 end;

                 if z=ord('i') then pause(son);
            end;

        setfillstyle(1,r);
        floodfill(x1,i1*15+25,8);
        floodfill(grille1[b1,1]*20+x1,(i1+grille1[b1,2])*15+25,8);
        floodfill(grille1[b1,3]*20+x1,(i1+grille1[b1,4])*15+25,8);
        floodfill(grille1[b1,5]*20+x1,(i1+grille1[b1,6])*15+25,8);

        setfillstyle(1,r2);
        floodfill(x2,i2*15+25,8);
        floodfill(grille2[b2,1]*20+x2,(i2+grille2[b2,2])*15+25,8);
        floodfill(grille2[b2,3]*20+x2,(i2+grille2[b2,4])*15+25,8);
        floodfill(grille2[b2,5]*20+x2,(i2+grille2[b2,6])*15+25,8);

{vv}    delay(Round(500/(exp(0.7*ln(n)))));
{vv        delay(Round(5000/(exp(0.7*ln(n)))));}
        fin1:=descent(t,grille1,b1,c1,i1);
        fin2:=descent(tbis,grille2,b2,c2,i2);
        until (z=2)or(fin1=i1)or(z=ord('x')-ord('0'))or(fin2=i2);


        if (fin1=i1)or(z=ord('x')) then begin
        setcolor(0);
        str(p1, s);
        outtextxy(334,90,s);
        p1:=p1+7*n;
        setcolor(3);
        str(p1, s);
        outtextxy(334,90,s);

        t[c1,i1]:=r;
        t[c1+grille1[b1,1],i1+grille1[b1,2]]:=r;
        t[c1+grille1[b1,3],i1+grille1[b1,4]]:=r;
        t[c1+grille1[b1,5],i1+grille1[b1,6]]:=r;
        
    {Suppress full lines j1}
    i1:=30;
    nbre:=0;
        repeat
        i1:=i1-1;
        absents:=true;
        presents:=true;
            for j:=1 to 10 do begin
                if t[j,i1]<>0 then absents:=false;
                if t[j,i1]=0 then presents:=false;
            end;

            if presents=true then begin
            nbre:=nbre+1;
            setcolor(0);
            str(lignes1, s);
            outtextxy(334,110,s);
            lignes1:=lignes1+1;
            setcolor(3);
            str(lignes1, s);
            outtextxy(334,110,s);

                if son=true then sound(440*nbre);
            
                for j:=1 to 10 do begin
                setfillstyle(1,0);
                floodfill(j*20+10,i1*15+25,8);
                end;
                for j:=1 to 10 do begin
                    for k:=i1 downto 1 do begin
                        if k>1 then begin
                        t[j,k]:=t[j,k-1];
                        setfillstyle(1,t[j,k-1]);
                        floodfill(j*20+10,k*15+25,8);
                        end else
                        t[j,1]:=0;
                    end;
                end;
            i1:=i1+1;
            nosound;
            end;
        until (absents)or(i1=1);

            if nbre>1 then begin
            ncp2:=nbre-1;
            ecp2:=c1;
            end;
            if ncp1<>0 then begin
                for j:=1 to 29-ncp1 do begin
                    for k:=1 to 10 do begin
                    t[k,j]:=t[k,j+ncp1];
                    setfillstyle(1,getpixel(k*20+10,(j+ncp1)*15+25));
                    floodfill(k*20+10,j*15+25,8);
                    end;
                end;

                setfillstyle(1,9);
                for j:=30-ncp1 to 29 do begin
                    for k:=1 to 10 do begin
                        if k<>ecp1 then begin
                        t[k,j]:=9;
                        floodfill(k*20+10,j*15+25,8);
                        end else begin
                        t[k,j]:=0;
                        setfillstyle(1,0);
                        floodfill(k*20+10,j*15+25,8);
                        setfillstyle(1,9);
                        end;
                    end;
                end;
            ncp1:=0;
            end;

            for j:=1 to 10 do
                if t[j,1]<>0 then test:=true;
        m1:=0;
        i1:=1;
        x1:=110;
        c1:=5;
        b1:=1;
        r:=random(7)+1;
        end;

        if (fin2=i2)or(z=ord('2')) then begin
        setcolor(0);
        str(p2, s);
        outtextxy(334,370,s);
        p2:=p2+7*n;
        setcolor(3);
        str(p2, s);
        outtextxy(334,370,s);

        tbis[c2,i2]:=r2;
        tbis[c2+grille2[b2,1],i2+grille2[b2,2]]:=r2;
        tbis[c2+grille2[b2,3],i2+grille2[b2,4]]:=r2;
        tbis[c2+grille2[b2,5],i2+grille2[b2,6]]:=r2;

    {Suppress full lines j2}
    i2:=30;
    nbre:=0;
        repeat
        i2:=i2-1;
        absents:=true;
        presents:=true;
            for j:=1 to 10 do begin
                if tbis[j,i2]<>0 then absents:=false;
                if tbis[j,i2]=0 then presents:=false;
            end;

            if presents=true then begin
            nbre:=nbre+1;
            setcolor(0);
            str(lignes2, s);
            outtextxy(334,390,s);
            lignes2:=lignes2+1;
            setcolor(3);
            str(lignes2, s);
            outtextxy(334,390,s);

                if son=true then sound(440*nbre);
            
                for j:=1 to 10 do begin
                setfillstyle(1,0);
                floodfill(j*20+410,i2*15+25,8);
                end;
                for j:=1 to 10 do begin
                    for k:=i2 downto 1 do begin
                        if k>1 then begin
                        tbis[j,k]:=tbis[j,k-1];
                        setfillstyle(1,tbis[j,k-1]);
                        floodfill(j*20+410,k*15+25,8);
                        end else
                        tbis[j,1]:=0;
                    end;
                end;
            i2:=i2+1;
            nosound;
            end;
        until (absents)or(i2=1);

            if nbre>1 then begin
            ncp1:=nbre-1;
            ecp1:=c2;
            end;

            if ncp2<>0 then begin
                for j:=1 to 29-ncp2 do begin
                    for k:=1 to 10 do begin
                    tbis[k,j]:=tbis[k,j+ncp2];
                    setfillstyle(1,getpixel(k*20+410,(j+ncp2)*15+25));
                    floodfill(k*20+410,j*15+25,8);
                    end;
                end;

                setfillstyle(1,9);
                for j:=30-ncp2 to 29 do begin
                    for k:=1 to 10 do begin
                        if k<>ecp2 then begin
                        tbis[k,j]:=9;
                        floodfill(k*20+410,j*15+25,8);
                        end else begin
                        tbis[k,j]:=0;
                        setfillstyle(1,0);
                        floodfill(k*20+410,j*15+25,8);
                        setfillstyle(1,9);
                        end;
                    end;
                end;
            ncp2:=0;
            end;
for j:=1 to 10 do
            if tbis[j,1]<>0 then test2:=true;

        m2:=0;
        i2:=1;
        x2:=510;
        c2:=5;
        b2:=1;
        r2:=random(7)+1;
        end;

    until (test)or(test2);


    if son=true then begin
        for a:=1500 downto 100 do begin
        sound(a);
        delay(10);
        end;
    nosound;
    end;

    if test then begin
        repeat
        for j:=1 to 25  do begin
            for k:=1 to 2 do begin
                    if k=1 then setcolor(4) else setcolor(0);
                outtextxy(100-3*j,20,'L');
                outtextxy(110-j,20,'o');
                outtextxy(120,20,'s');
                outtextxy(130+j,20,'t');
                outtextxy(490-3*j,20,'W');
                outtextxy(500-j,20,'i');
                outtextxy(510,20,'n');
                    if k=1 then delay(d500);
            end;
        end;
        for j:=25 downto 1  do begin
            for k:=1 to 2 do begin
                if (k=1) then setcolor(4) else setcolor(0);
            outtextxy(100-3*j,20,'L');
            outtextxy(110-j,20,'o');
            outtextxy(120,20,'s');
            outtextxy(130+j,20,'t');
            outtextxy(490-3*j,20,'W');
            outtextxy(500-j,20,'i');
            outtextxy(510,20,'n');
                if k=1 then delay(d500);
            end;
        end;
    until keypressed;
    end else begin
       repeat
       for j:=1 to 25  do begin
            for k:=1 to 2 do begin
                    if k=1 then setcolor(4) else setcolor(0);
                outtextxy(100-3*j,20,'W');
                outtextxy(110-j,20,'i');
                outtextxy(120,20,'n');
                outtextxy(130+j,20,'n');
                outtextxy(490-3*j,20,'L');
                outtextxy(500-j,20,'o');
                outtextxy(510,20,'s');
                outtextxy(520+j,20,'t');
                    if k=1 then delay(d500);
            end;
        end;
        for j:=25 downto 1  do begin
            for k:=1 to 2 do begin
                if (k=1) then setcolor(4) else setcolor(0);
            outtextxy(100-3*j,20,'W');
            outtextxy(110-j,20,'i');
            outtextxy(120,20,'n');
            outtextxy(490-3*j,20,'L');
            outtextxy(500-j,20,'o');
            outtextxy(510,20,'s');
            outtextxy(520+j,20,'t');
                if k=1 then delay(d500);
            end;
        end;
    until keypressed;
    end;
end.